#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include <errno.h>

#include <glib.h>

#include <utillib.h>

#include "download-thread.h"

GType           download_thread_get_type       ();
static void     download_thread_class_init     (DownloadThreadClass *klass);
static void     download_thread_init           (DownloadThread *thread);

static gpointer parent_class = NULL;

void *download_thread(void *param);

GType download_thread_get_type ()
{
    static GType download_thread_type = 0;

    if (!download_thread_type)
    {
        static const GTypeInfo download_thread_info =
        {
            sizeof (DownloadThreadClass),
            (GBaseInitFunc) NULL,
            (GBaseFinalizeFunc) NULL,
            (GClassInitFunc) download_thread_class_init,
            NULL,           /* class_finalize */
            NULL,           /* class_data */
            sizeof (DownloadThread),
            0,              /* n_preallocs */
            (GInstanceInitFunc) download_thread_init
        };

        download_thread_type = g_type_register_static (G_TYPE_OBJECT,
                                                       "DownloadThread",
                                                       &download_thread_info,
                                                       0);
    }

    return download_thread_type;
}

static void download_thread_class_init (DownloadThreadClass *klass)
{
    parent_class = g_type_class_peek_parent (klass);
}

static void download_thread_init (DownloadThread *thread)
{
	thread->addr = 0;
	thread->redirect = 0;
    thread->stop = 0;
}

DownloadThread *download_thread_new()
{
    return DOWNLOAD_THREAD (g_object_new (download_thread_get_type (), NULL));
}

void download_thread_delete(DownloadThread *thread)
{
//FIXME: use the finalize func
//	free(thread);
}
