#include <stdlib.h>

#include "list.h"

struct _list
{
	Node *begin;
	Node *end;
	int size;
};

struct _node
{
	void *data;
	Node *next;
	Node *previous;
};

List *list_new()
{
	List *l = malloc(sizeof(List));
	l->begin = 0;
	l->end = 0;
	l->size = 0;
	return l;
}

void list_add(List *l, Node *n)
{
	if (l->begin == 0)
	{
		l->begin = n;
		l->end = n;
	}
	else
	{
		l->end->next = n;
		n->previous = l->end;
		l->end = n;
	}
	l->size++;
}

void list_remove(List *l, Node *n)
{
	if (n->previous)
		n->previous->next = n->next;
	else
		l->begin = n->next;

	if (n->next)
	{
		n->next->previous = n->previous;
		n->next = 0;
	}
	else
		l->end = n->previous;

	n->previous = 0;

	l->size--;
}

Node *list_begin(List *l)
{
	return l->begin;
}

Node *list_next(Node *n)
{
	return n->next;
}

int list_size(List *l)
{
	return l->size;
}

Node *list_node_new(void *d)
{
	Node *n = malloc(sizeof(Node));
	n->data = d;
	n->next = 0;
	n->previous = 0;
	return n;
}

void list_node_delete(Node *n)
{
	free(n);
}

void *list_node_data(Node *n)
{
	return n->data;
}

